import modal

from ..ffmpeg_app import ffmpeg_worker_image, app, config, s3_mount, local_copy_to_s3, output_path_prefix

with ffmpeg_worker_image.imports():
    from BowongModalFunctions.models.media_model import MediaSource
    from BowongModalFunctions.models.web_model import SentryTransactionInfo, WebhookNotify, FFMPEGResult
    from BowongModalFunctions.utils.PathUtils import FileUtils
    from BowongModalFunctions.utils.SentryUtils import SentryUtils
    from BowongModalFunctions.utils.VideoUtils import VideoUtils
    import sentry_sdk
    from typing import Optional, Tuple
    from modal import current_function_call_id


    @app.function(timeout=600, cloud="aws",
                  max_containers=config.ffmpeg_worker_concurrency,
                  volumes={
                      s3_mount: modal.CloudBucketMount(
                          bucket_name=config.S3_bucket_name,
                          secret=modal.Secret.from_name("aws-s3-secret",
                                                        environment_name=config.modal_environment),
                      ),
                  }, )
    @modal.concurrent(max_inputs=1)
    async def ffmpeg_loop_fill(media: MediaSource, audio: MediaSource,
                               sentry_trace: Optional[SentryTransactionInfo] = None,
                               webhook: Optional[WebhookNotify] = None) -> Tuple[
        FFMPEGResult, Optional[SentryTransactionInfo]]:
        fn_id = current_function_call_id()

        @SentryUtils.sentry_tracker(name="视频匹配音频长度", op="ffmpeg.loop.fill", fn_id=fn_id,
                                    sentry_trace_id=sentry_trace.x_trace_id if sentry_trace else None,
                                    sentry_baggage=sentry_trace.x_baggage if sentry_trace else None)
        @SentryUtils.webhook_handler(webhook=webhook, func_id=fn_id)
        async def ffmpeg_process(media: MediaSource, audio: MediaSource, func_id: str) -> FFMPEGResult:
            video_path = f"{s3_mount}/{media.cache_filepath}"
            audio_path = f"{s3_mount}/{audio.cache_filepath}"

            local_output, metadata = await VideoUtils.ffmpeg_fill_longest(video_path=video_path,
                                                                          audio_path=audio_path,
                                                                          output_path=f"{output_path_prefix}/{config.modal_environment}/loop_fill/{func_id}/output.mp4")
            s3_outputs = local_copy_to_s3([local_output])
            return FFMPEGResult(urn=s3_outputs[0], metadata=metadata,
                                content_length=FileUtils.get_file_size(local_output), )

        result = await ffmpeg_process(media=media, audio=audio, func_id=fn_id)

        if not sentry_trace:
            sentry_trace = SentryTransactionInfo(x_trace_id=sentry_sdk.get_traceparent(),
                                                 x_baggage=sentry_sdk.get_baggage())

        return result, sentry_trace
